<!doctype html>
<html lang="en">

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="/css/bootstrap.min.css">
    <link rel="icon" type="/image/png" href="/images/hybridcloud.png">
    <link rel="stylesheet" href="/css/home.css">

    <script defer src="js/jquery-3.3.1.min.js"></script>
    <script defer src="js/bootstrap.min.js"></script>

    <title>CoC's Quote of the Day Load Generator</title>
</head>

<body>

    <main role="main">

        <section class="jumbotron text-center">
            <div class="container">
                <h1 class="jumbotron-heading">Quote of the Day App <br/> Load Generator</h1>
            </div>
        </section>

        <div class="container text-center" style="padding-top: 80px;">
            <button id="loadGeneratorBtn" type="button" class="btn" onclick="toggleLoad()">Start Load Generator</button>
        </div> 

        <div class="container text-center" style="padding-top: 80px;">
            <span id="noRequests"></span>
        </div> 


    </main>


    <script>

        var loadRunning;
        var reqInterval = null;

        window.onload = (event) => {
            refresh();
            refreshNoRequests();
        };

        function refresh() {
            $.ajax({
                type: 'GET',
                url: '/load',
                success: updateLoadUI,
                headers: { "Accept": 'accept: application/json' }
            });
        }

        function refreshNoRequests(){
            $.ajax({
                type: 'GET',
                url: '/requests',
                success: updateNoRequest,
                headers: { "Accept": 'accept: application/json' }
            });
        }

        function updateNoRequest(data){
            var requests = data.requests;
            var since = data.since;
            $('#noRequests').html(requests+' use case executions completed since '+since);
        }

        function updateLoadUI(data) {
            if( data.running ) {
                loadRunning = true;
                $('#loadGeneratorBtn').removeClass("btn-success");
                $('#loadGeneratorBtn').addClass("btn-danger");
                $('#loadGeneratorBtn').html("Stop Generating Load");
                if( reqInterval == null ) {
                    reqInterval = setInterval( refreshNoRequests, 2000);
                } 
            } else {
                loadRunning = false;
                $('#loadGeneratorBtn').removeClass("btn-danger");
                $('#loadGeneratorBtn').addClass("btn-success");
                $('#loadGeneratorBtn').html("Start Load Generator");
                if( reqInterval != null ) {
                    clearInterval(reqInterval);
                    refreshNoRequests = null;
                    $('#noRequests').html("");
                } 
            }
        }

        function toggleLoad() {
            var payload;
            if( loadRunning ) {
                payload = { "action": "stop"};
            } else {
                payload = { "action": "start"};
            }
            $.ajax({
                type: 'PUT',
                url: '/load',
                success: updateLoadUI,
                contentType: "application/json",
                data: JSON.stringify(payload)
            });
        }

        function resetAll() {
            $.ajax({
                type: 'POST',
                url: '/reset'
            });
            $('#resetBtn').addClass('disabled');
            setTimeout( () => { $('#resetBtn').removeClass('disabled'); }, 1000);
        }

    </script>

</body>

</html>